#include "ARMCFunctions.h"

// CSUB for twofingers@tbs Game of Life
// Calculate the next generation = p[]
// Field (=o[]) dimensions = height:62 * width:62 (ie 1-62 excluding borders)
void calc(long long o[],long long p[], int *height, int *width){
int hy;         // y index
int wx;         // x index
int w=*width;   // x limit
int h=*height;  // y limit
int n;          // neighbors counter
unsigned long long int xl,x,xr;      // x bitmask neighbors, x+1,x,x-1

	for(hy=1;hy<=h;hy++){
		for(wx=0;wx < w;wx++){
      xr=(long long int)((unsigned long long int)1 << (long long int)(wx));			
			x =xr<<1;	 
	    xl= x<<1;  

			n=0;

			if (o[hy]   & xl) n++;
			if (o[hy]   & xr) n++;

			if (o[hy-1] & xl) n++;
			if (o[hy+1] & xl) n++;  

			if (o[hy-1] & x) n++;
			if (o[hy+1] & x) n++;

			if (o[hy-1] & xr) n++;
			if (o[hy+1] & xr) n++;				
			
			if ((n==3 )||(n==2 && (o[hy] & x))) {
				p[hy]=p[hy] | x;
			}                
		}
	}	
} 