#include "ARMCFunctions.h"

#define RED    0xFFF0000
#define YELLOW 0xFFFFF00
#define xOffset 9
#define yOffset 11

// core function for LIFE XL for MMBasic CMM2_Beta - V5.05.06RC2
void core(long long o[],long long p[], int *height, int *width){
int hy;         // y index
int wx;         // x index
int w=*width;   // x limit
int h=*height;  // y limit
int n;          // neighbors counter
unsigned long long int x0,x1,x2;      // x bitmask neighbors, x+1,x,x-1

	for(hy=1;hy<=h;hy++){
		for(wx=w;wx;wx--){
      x2=(long long int)((unsigned long long int)1 << (long long int)(62-wx));			
			x1=x2<<1;	 
	    x0=x1<<1;  

			n=0;

			if (o[hy]   & x0) n++;
			if (o[hy]   & x2) n++;

			if (o[hy-1] & x0) n++;
			if (o[hy+1] & x0) n++;  

			if (o[hy-1] & x1) n++;
			if (o[hy+1] & x1) n++;

			if (o[hy-1] & x2) n++;
			if (o[hy+1] & x2) n++;				
			
			if (n==3 ) {
				p[hy]=p[hy] | x1;
			}                
			else if (n==2 && (o[hy] & x1)){
				p[hy]=p[hy] | x1;	 		 						 
			}	
			if (o[hy] & x1) 
			  DrawCircle(wx*8+xOffset, hy*8+yOffset, 3, 1, RED, YELLOW, 1.0);
		}		
	}
	for(hy=1;hy<=h;hy++){
		o[hy]=p[hy];	// Copy array
		p[hy]=0;      // Clear world
	}
}